from ...services import project,printer
import json

def view(task_name=None):

    project.check_is_job_project()

    with open('./job.json', 'r') as f:
        obj = json.loads(f.read())

    # job Description
    printer.print_title('Job Description:')
    printer.print_job_desc(obj)

    #dependencies:
    deps = obj.get('TaskDag').get('Dependencies')
    #deps = {'Aaaa':['B','Colsl'], 'B':['D','Evvasdfadsfasdfasdfas'], 'Colsl':['G'], 'G':['H'],'D':['H']}
    deps = merge_deps(obj.get('TaskDag').get('TaskDescMap').keys(), deps)

    deps_result = printer.print_deps(deps)
    matric = deps_result[1]


    if task_name:
        v = obj.get('TaskDag').get('TaskDescMap').get(task_name)
        if v:
            printer.print_title('Task Description for [%s]:' % task_name)
            printer.print_task_desc(task_name, v)
        else:
            raise Exception('Not found task %s' % task_name)
    else:
        printer.print_title('Task Descriptions:')
        task_descs = obj.get('TaskDag').get('TaskDescMap')

        c=0
        for n in matric:
            for n2 in n:
                c = c+1
                if task_descs.get(n2):
                    printer.print_task_desc('%d.%s'% (c, n2), task_descs[n2])

    #validate

def merge_deps(key_set, deps):
    uniq_set = set()
    for n in deps:
        uniq_set.add(n)
        for k in deps[n]:
            uniq_set.add(k)

    for k in key_set:
        if k not in uniq_set:
            deps[k]=[]
    return deps


